#!/usr/local/bin/python


import sys, os

marker = "-------------------------------------------"
failed = []

tests = ('TestBuffer', 'TestCond1', 'TestCond2', 'TestGP', 'TestInit',
	 'TestRMFI_Invoke', 'TestRMFI_MInvoke', 'TestThreads', 'TestSync')

files = {
    'TestBuffer':      { 'nexus': [" "],          'mpi': ["mpirun -np 2 "] },
    'TestCond1':       { 'nexus': [" "],	  'mpi': [""] },
    'TestCond2':       { 'nexus': [" "],	  'mpi': [""] },
    'TestGP':          { 'nexus': [" -nx -n 1 "], 'mpi': ["mpirun -np 2 "] },
    'TestInit':        { 'nexus': [" "],	  'mpi': [""] },
    'TestRMFI_Invoke': { 'nexus': [" -nx -n 1 "], 'mpi': ["mpirun -np 2 "] },
    'TestRMFI_MInvoke':{ 'nexus': [" -nx -n 2 "], 'mpi': ["mpirun -np 3 "] },
    'TestThreads':     { 'nexus': [" "],	  'mpi': [""] },
    'TestSync':        { 'nexus': [" "],	  'mpi': [""] },
}

if len(sys.argv) != 2:
   print "Usage: run-tests.py [nexus | mpi]"
else:
   runtime = sys.argv[1]
   
   print marker
   os.system("rm -f run-tests.log")
   os.system("date > run-tests.log")

   if runtime == 'nexus':
      tests = tests[1:]

   for name in tests:

      if runtime == 'nexus':
         output = os.popen(name + files[name][runtime][0] + ">> run-tests.log ; echo $?", "r").readline()
      elif runtime == 'mpi':
         output = os.popen(files[name][runtime][0] + name + " >> run-tests.log ; echo $?", "r").readline()

      if output[0] == "0":
         print "\tTesting: " + name + " ... Succeeded"
      else:
         failed.append(name)
         print "\tTesting: " + name + " ... Failed"

   print marker

   if failed <> []:
      print "The following tests failed:"
      for name in failed:
         print "\t" + name
   else:
      print "All Tests completed successfully"

   print marker


